#pragma once
#include <memory>

#include "IService.h"
#include "types.h"


namespace Engine
{

class Application : public IService
{
public:
	Application();

	bool init()		override;
	bool shutdown() override;

	void start();

private:
	AppRootRef	m_appRoot;
	ViewPtr		m_view;
	MediaPtr	m_media;
	ScenePtr	m_scene;
	InputPtr	m_input;
	PhysicsPtr	m_physics;

	SceneEntity::HUDPtr m_hud;

};

}


